#define F_CPU 14745600UL  	//freq 14,7456 MHz
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include <string.h>
#include <stdio.h> 
#include <stdint.h>
#include "SPI_routines.h"
#include "SD_routines.h"
#include "UART_routines.h"
#include "FAT32.h"
#include "knihovnaLCD.c"
#include "dalas.c"


volatile unsigned char vlozena=0;
volatile unsigned char vlozena1=0;

ISR(INT0_vect)
{
vlozena=1;	
}
ISR(INT1_vect)
{
vlozena1=1;	
}

void port_init(void)
{
    

  PORTA = 0x00;
  DDRA  = 0x00;
  PORTB = 0b00100010; // set SCK hi
  DDRB  = 0b11110111; //MISO line i/p, rest out 
  DDRD  = 0x00; //vstup
  PORTD = 0xFF;
  PORTC = 0x00;
  DDRC  = 0xFF;

}


//call this routine to initialize all peripherals
void init_devices(void)
{
  port_init();
  spi_init();
  uart0_init();
  sei();


  MCUCR = 0x00;
  TIMSK = 0x00; //timer interrupt sources
  //all peripherals are now initialized
}


void mereni_tep(void){


	LCD_Init();
	LCD_Clear();
	_delay_ms(2);


teplota1=Read_Temperature();

T=(float) teplota1/100;
    LCD_Position(0 , 0);
	_delay_ms(2);
    sprintf (bufferT, "T= %4.2f stupnu", T);
	LCD_WriteString(bufferT);


_delay_ms(500);
TX_NEWLINE;
transmitString_F(PSTR("Teplota:  "));
transmitString(bufferT);
TX_NEWLINE;
}




//*************************** MAIN *******************************//
int main(void)
{

  unsigned char option, error, a=49, i, j,t, data=0x00, edata=0x00;
  unsigned char fileName[13];
  char i1;
  int i2, i3, i4 = 3;
  char new_value[i4];
  unsigned int delay, k, fp, teplota1, bufferT[50],bunka = 0x00, bunka1,prvni=0x01,zaloha=0x01,z, bunkaX;


  // External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: On
// INT1 Mode: Falling Edge
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x0A;
EICRB=0x00;
EIMSK=0x03;
EIFR=0x03;
  
  _delay_ms(100);  //delay for VCC stabilization
  
  init_devices();
  
  
  transmitString_F (PSTR("\n\r\n\r****************************************************"));
  transmitString_F (PSTR("\n\r        ~~ SD Datalogger - by M. Havlena ~~"));
  transmitString_F (PSTR("\n\r****************************************************\n\r"));
  cardType = 0;

  for (i=0; i<10; i++)
  {
  	error = SD_init();

  	if(!error) break;
  }

  if(error)
  {
  	if(error == 1) transmitString_F(PSTR("SD karta nebyla nalezena.."));
  	if(error == 2) transmitString_F(PSTR("Inicializec eneprobhla v podku.."));
  
  }

  switch (cardType)
  {
  	case 1:transmitString_F(PSTR("Standard Capacity Card (Ver 1.x) Detekovana!"));
  		   break;
  	case 2:transmitString_F(PSTR("High Capacity Card Detected!"));
  		   break;
  	case 3:transmitString_F(PSTR("Standard Capacity Card (Ver 2.x) Detekovana!"));
  		   break;
  	default:transmitString_F(PSTR("Neznama SD karta nebo neni vlozena!"));
  		   break; 
  }

  error = getBootSectorData (); //read boot sector and keep necessary data in global variables
  if(error) 
  {
   	transmitString_F (PSTR("\n\rFAT32 nenalezena!"));  //FAT32 incompatible drive
    while(1);
  }

  SPI_HIGH_SPEED;	//SCK - 4 MHz
  _delay_ms(1);   	//some delay for settling new spi speed

 //For displaying menu on hyper terminal, the key (psh-button) must be kept pressed while 
 //powering ON or while reset. If key is not kept pressed, the program will not display menu and it will 
 //simply wait for start recording command (i.e. pressing of key afterwards)

  while(1)
  {
  	transmitString_F(PSTR("\n\r-> 1 : Seznam souboru                          <-"));
  	transmitString_F(PSTR("\n\r-> 2 : Precist soubor                          <-"));
  	transmitString_F(PSTR("\n\r-> 3 : Smazat soubor                           <-"));
	transmitString_F(PSTR("\n\r-> 4 : Kapacita SD karty                       <-")); 
	transmitString_F(PSTR("\n\r-> 5 : Teplota                                 <-"));
	transmitString_F(PSTR("\n\r-> 6 : Zaznam dat (datalogger)                 <-"));
	transmitString_F(PSTR("\n\r-> 7 : Synchronizace dat s EEPROM              <-"));
	transmitString_F(PSTR("\n\r-> 8 : Smazani ulozenych souboru na SD karte   <-"));

  	transmitString_F(PSTR("\n\r\n\r> Zvolte moznost:"));
  	option = receiveByte();
  	transmitByte(option);

////////////////////////////////////////////////////////////////////////	

 if (vlozena==1){  //vnitn karta(spodn)
	 vlozena=0;
	  _delay_ms(100);  //delay for VCC stabilization
  
  init_devices();
  sei();

  cardType = 0;
  for (i=0; i<10; i++)
  {
  	error = SD_init();
  	if(!error) break;
  }

  if(error)
  {
  	if(error == 1) transmitString_F(PSTR("SD karta nebyla nalezena.."));
  	if(error == 2) transmitString_F(PSTR("Inicializec eneprobhla v podku.."));
  
  }

  switch (cardType)
  {
  	case 1:transmitString_F(PSTR("Standard Capacity Card (Ver 1.x) Detekovana!"));
  		   break;
  	case 2:transmitString_F(PSTR("High Capacity Card Detected!"));
  		   break;
  	case 3:transmitString_F(PSTR("Standard Capacity Card (Ver 2.x) Detekovana!"));
  		   break;
  	default:transmitString_F(PSTR("Neznama SD karta nebo neni vlozena!"));
  		   break; 
  }

  error = getBootSectorData (); //read boot sector and keep necessary data in global variables
  if(error) 
  {
   	transmitString_F (PSTR("\n\rFAT32 nenalezena!"));  //FAT32 incompatible drive
    while(1);
  }

  SPI_HIGH_SPEED;	//SCK - 4 MHz
  _delay_ms(1); 
}

////////////////////////////////////////////////////////////////////////////////////////////	
/*  //inicializace horni karty - pozdejsi pouziti
  if (vlozena1==1){   //vyjmateln(horn) karta
  SD_CS_DEASSERT;

  SD_CS_ASSERT1;
  vlozena1=0;
  _delay_ms(100);  //delay pro VCC stab.
  
  setb(PORTB,4);
  clrb(PORTB,5);
  init_devices();
 

  cardType = 0;
  for (i=0; i<10; i++)
  {
  	error = SD_init1();
  	if(!error) break;
  }

  if(error)
  {
  	if(error == 1) transmitString_F(PSTR("SD karta nebyla nalezena.."));
  	if(error == 2) transmitString_F(PSTR("Inicializec eneprobhla v podku.."));
  
  }

  switch (cardType)
  {
  	case 1:transmitString_F(PSTR("Standard Capacity Card (Ver 1.x) Detekovana!"));
		   TX_NEWLINE;	
  		   break;
  	case 2:transmitString_F(PSTR("High Capacity Card Detected!"));
		   TX_NEWLINE;
  		   break;
  	case 3:transmitString_F(PSTR("Standard Capacity Card (Ver 2.x) Detekovana!"));
  		   TX_NEWLINE;
		   break;
  	default:transmitString_F(PSTR("Neznama SD karta nebo neni vlozena!"));
  		   TX_NEWLINE;
		   break; 
  }

  error = getBootSectorData(); //read boot sector and keep necessary data in global variables
  if(error) 
  {
   	transmitString_F (PSTR("\n\rFAT32 nenalezena!"));  //FAT32 nelze nalzt
    while(1);
  }

  SPI_HIGH_SPEED;	//SCK - 4 MHz
  _delay_ms(1);
*/
/*
//funkce pro zapsn dat na horn kartu - pozdejsi pouziti
TX_NEWLINE;
transmitString_F(PSTR(" Probh synchronizace karty.."));
TX_NEWLINE;
	for(i=0; i<9;i++){
	fileName[0]= i ;
	fileName[1]='.';
	fileName[2]='T';
	fileName[3]='X';
	fileName[4]='T';
	deleteFile(fileName);
	}
	setb(DDRB,4);  //nastaven spodn karty
	clrb(DDRB,5);  //zruen horn karty
	error = readANDwriteFile( READ, fileName);
					if(error == 1) transmitString_F(PSTR("Soubor neexistuje.."));
					TX_NEWLINE;


*/


  ////////////////////////////////////////////////////////////////////////////////
	
	switch (option)
	{
		
		case '1':TX_NEWLINE;
  		  		 findFiles(GET_LIST,0);
				 TX_NEWLINE;
				 data = receiveByte();
            		
				 break;
  		case '2':
		
		case '3':transmitString_F(PSTR("\n\rVlozte nazev souboru: "));
          		 for(i=0; i<13; i++) {
				 fileName[i] = 0x00;   //vymazn pedem uloenho souboru
				 }
          		 i=0;
          		 while(1)
          		 {
            		data = receiveByte();
            		if(data == 0x0d) break;  //'ENTER' stisknuto
					if(data == 0x08)	//'Back Space' stisknuto
	 				{ 
	   					if(i != 0)
	   					{ 
	     					transmitByte(data);
							transmitByte(' '); 
	     					transmitByte(data); 
	     					i--; 
	   					} 
	   					continue;     
	 				}
					if(data <0x20 || data > 0x7e) continue;  //platn znaky, anglick
					transmitByte(data);
            		fileName[i++] = data;
            		if(i==13){transmitString_F(PSTR(" Jmeno souboru prilis dlohe..")); break;}
          		}
          		if(i>12) break;
       
	      		TX_NEWLINE;
		  		if(option == '2') 
				{ 
					error = readFile( READ, fileName);
					TX_NEWLINE;
					if(error == 1) transmitString_F(PSTR("Soubor neexistuje.."));
					TX_NEWLINE;
					data = receiveByte();
            		if(data == 0x0d) break;  //'ENTER' stisknuto
				}
		  		if(option == '3') deleteFile(fileName);
				data = receiveByte();
            		
				
		     		
            	
          		break;
		case '4':memoryStatistics();
			     data = receiveByte();
            	 
				 break; 
		case '5':mereni_tep();
		         data = receiveByte();
            	 
				 break;
		case '6': // men
				 

				 fileName[0] = a;
				 a++;
				 fileName[1] = '.';
			     fileName[2] = 't';
		         fileName[3] = 'x';
		         fileName[4] = 't';
				 
				 TX_NEWLINE;
				 transmitString_F(PSTR("Mereni, cekejte prosim..."));
				 TX_NEWLINE;
				  // transmitString_F(PSTR(" Pro preruseni mereni stisknete ENTER!  "));

				 
				 bunka=zaloha;                                       //naten prvn adresy(resp. dal adresy
				 													 //pi dalch cyklech		
				 i=0;
				 for(j=0;j<30; j++)                                  //nastaven mcho cyklu
				 {                                 
			 
				 teplota1=Read_Temperature();                        //peten teploty z idla 
				 teplota1=teplota1/100;															
				 
					i2 = (int) teplota1;                             //prevedeni ascii hodnoty na int

					round(teplota1);							     //zaokrouhlen teploty na cel sla
				    eeprom_write_byte(bunka,teplota1);               //uloen bajtu dat do eeprom na adresu v bunce
					 
					sprintf(new_value, "%d", i2);                    // zapsn zskanho sla do textov reprezentace

					for (i3 = 0;i3<i4;i3++)                          //pepsn naeho sla tam kam chceme po znacch
					 if (new_value[i3] > 47 && new_value[i3] < 58)   //je to teplota v slech, take jen hodnoty 0 a 9
					  {
  					  dataString[i++] = new_value[i3];				 //zapsn zskan hodnoty do bufferu
  					  }
				
				 dataString[i++] = ';';								 //oddlova mezi hodnotami
				 
				 _delay_ms(300);                                     //spodn z dvodu mc cyklu
				 bunka++;										     //dal adresa EEPROM
				 }
				 
				 dataString[i++] = '\r';										
				 dataString[i] = '\n';							     //oddkovn po posledn hodnot
   				 writeFile(fileName);								 //zapsn souboru na SD kartu
		 		 zaloha=bunka;                                       //zaloha dal voln adresy pro dal cyklus
				 
				 
				 j=0;
				 break;
		case '7':for(i=0; i<13; i++) fileName[i] = 0x00;   //vymazn pedem uloenho souboru
				 z=a;									   //zloha sla souboru
				 for(a=48;a<=90;a++){                      
				 fileName[0] = a;
				 fileName[1] = '.';
				 fileName[2] = 't';
				 fileName[3] = 'x';
			     fileName[4] = 't';
				 deleteFile(fileName);					   //vymazn vech namench soubor
				 }
				 a=z;                                      //obnoven sla souboru
			 
				 if(zaloha==0x01) {                        //pokud je zloha rovna 1, nebyly nahrny dn daty
				 TX_NEWLINE;							   //nen co synchronizovat
				 transmitString_F(PSTR("Zadna data k synchronizaci!"));
				 TX_NEWLINE;
				 break;
				 }

				 TX_NEWLINE;
				 transmitString_F(PSTR("Synchronizace probiha, cekejte prosim..."));
				 TX_NEWLINE;

				 i=0;
				 bunkaX=0;								          //potadlo prchod
                 for(bunka1=0x01; bunka1<zaloha ; bunka1++){      //natu do bunka1 adresu prvnho volnho bajtu
				 
				 
				 edata = eeprom_read_byte(bunka1);				  //natu bajt z EEPROM 

				  i1 = (char) edata;							  //peveden ascii hodnoty na int

				
					sprintf(new_value, "%d"  , i1);               // zapsn zskanho sla do textov reprezentace

					for (i3 = 0;i3<i4;i3++)                       // prepsani naseho cisla tam kam chceme po znacich
					 if (new_value[i3] > 47 && new_value[i3] < 58)// zajimaji nas jen cislovky 0 az 9
					  {
  
					  dataString[i++] = new_value[i3];			  //zapsn dat do bufferu
  					  }

				 			 
				 dataString[i++] = ';';                           //oddlen mezi daty
				 bunkaX++;                                        //potadlo hodnot
				 if(bunkaX==30)                                   //po 30 hodnotch uloit obsah bufferu na kartu
				 {
				 dataString[i++] = '\r';                         
				 dataString[i] = '\n';                            //oddkovn v souboru
				 for(i=0; i<13; i++) fileName[i] = 0x00;          //vymazn monho nzvu
			     fileName[0] = 'E';
				 fileName[1] = '.';
				 fileName[2] = 't';
				 fileName[3] = 'x';
			     fileName[4] = 't';								  //vytvoen nzvu souboru
					writeFile(fileName);						  //zapsn souboru
				    i=0;
					bunkaX=0;									  //vynulovn potadla
				 }
				 

				 }
				 dataString[i++] = '\r';						
				 dataString[i] = '\n';							  //konen oddkovn
				 
				 for(i=0; i<13; i++) fileName[i] = 0x00;
			     fileName[0] = 'E';
				 fileName[1] = '.';
				 fileName[2] = 't';
				 fileName[3] = 'x';
			     fileName[4] = 't';
 				 
   				 writeFile(fileName);							  //zapsn dat do souboru
				 
				 break;	 

		case '8':
			     z=a;                       //zaloha znaku 
				 for(a=48;a<=100;a++){      //vymazn vech namench soubor
				 fileName[0] = a;
				 fileName[1] = '.';
				 fileName[2] = 't';
				 fileName[3] = 'x';
			     fileName[4] = 't';
				 deleteFile(fileName);
				 }				 
			     a=z;                       //vraceni zalohy znaku
				 data = receiveByte();
		break;
		
     }
}

		
}//konec mainu

